#!/bin/sh
#
-# mbuild - automate builds with sbuild and dinstall the result
+# - automate builds with sbuild and dinstall the result
#
# Copyright (c) 2008 martin f. krafft <madduck@debian.org>
# Released under the terms of the Artistic Licence 2.0.
ME="${0##*/}"
BUILDDIR="$(mktemp -dt $ME.XXXXXXXX)"
-trap "cd / && rm -R '$BUILDDIR'" 0
+trap "cd /tmp && rm -r '$BUILDDIR'" 0
BUNDLE_DIR="${TMPDIR:-/tmp}"
TARGET_DIR="$PWD"
-dinstall() {
+copy_back_files() {
echo "Copying files destined for $1 back to $TARGET_DIR..."
dcmd cp -v "$2" "$TARGET_DIR"
}
+dinstall() {
+ copy_back_files "$@"
+}
+print_bundle_location() {
+ echo "Bundle available at $@ ."
+}
KEYID=
echo
echo "Valid options are:"
cat <<-_eof | column -s\& -t
- --dist & specify the target distribution (default: sid)
+ --dist & specify the target distribution (default: from changes file)
--arch & specify the target architecture (default: $DEB_BUILD_ARCH)
+ -sa & pass --force-orig-source to sbuild
+ -B & do a binary-only build
-h|--help & show this output.
-V|--version & show version information.
_eof
}
+binonly=0
sbuild_args=
schangesfile=
arch=
-dist=
for opt in "$@"; do
case "$opt" in
-h|--help) usage; exit 0;;
-V|--version) about; exit 0;;
--arch=*) arch="${opt#--arch=}";;
- --dist=*) dist="${opt#--dist=}";;
-sa) sbuild_args="${sbuild_args:+$sbuild_args }--force-orig-source";;
+ -B) binonly=1;;
--*) sbuild_args="${sbuild_args:+$sbuild_args }$opt";;
*_source.changes)
if [ -z "$schangesfile" ]; then
fi
;;
*)
- echo "E: unknown option: $opt" >&1
+ echo "E: unknown option: $opt" >&2
exit 1
;;
esac
fi
[ -z "$arch" ] && arch="$DEB_BUILD_ARCH"
-[ -z "$dist" ] && dist="unstable"
+
+dist="$(sed -ne 's,Distribution: ,,p' "$schangesfile")"
schangesfile_basename="${schangesfile##*/}"
+packagename="${schangesfile_basename%%_*}"
packagenameversion="${schangesfile_basename%_*}"
+debversion="${packagenameversion#*_}"
+upstream_version="${debversion%-*}"
+dscfile_basename="$packagenameversion".dsc
case "$schangesfile" in
*/*) cd "${schangesfile%/*}";;
cd "$BUILDDIR"
-sbuild $sbuild_args --arch="$arch" --arch-all --dist="$dist" --keyid=$KEYID \
- "$packagenameversion".dsc
+dcmd "$dscfile_basename" | while read f; do
+ test -f "$f" && continue
+
+ case "$f" in
+ *.tar.gz)
+ last_version="$(apt-cache madison mdadm | sed -rne "s,.+(\<${upstream_version}[^[:space:]]+).*,\1,p")"
+ echo "I: fetching missing tarball for $upstream_version (from $last_version)…" >&2
+ apt-get --tar-only --only-source source "${packagename}=${last_version}"
+ ;;
+ *)
+ echo "E: I do not know how to obtain the file: $f" >&2
+ exit 1
+ ;;
+ esac
+done
+
+[ "$binonly" = 0 ] && sbuild_args="${sbuild_args:+$sbuild_args }--source --arch-all"
+
+sbuild $sbuild_args --arch="$arch" --dist="$dist" --keyid=$KEYID \
+ "$dscfile_basename"
changesfile="${packagenameversion}_${arch}.changes"
-dinstall "$dist" "$schangesfile"
-dinstall "$dist" "$changesfile"
+#mergechanges "$schangesfile" "$changesfile" > temp-combined.changes
+#mv temp-combined.changes "$changesfile"
+#changestool "$changesfile" updatechecksums
-mv "$changesfile" "${changesfile}.binonly"
-mergechanges "$schangesfile" "${changesfile}.binonly" > "$changesfile"
-rm "${changesfile}.binonly" "$schangesfile"
+#sign_changes_file "$changesfile"
+
+dinstall "$dist" "$changesfile"
DATESTR="$(date +%Y.%m.%d.%H%M%S)"
BUILD_PREFIX="${packagenameversion}_${arch}.${DATESTR}"
bundle="${BUNDLE_DIR}/${BUILD_PREFIX}".bundle.tar
tar -chf "$bundle" *
+chmod 644 "$bundle"
rm -r "$BUILDDIR"
trap - 0
-echo "Bundle available at $bundle ."
+print_bundle_location "$bundle"
exit 0